Index: squid/src/icp_v2.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v2.c,v
retrieving revision 1.3.6.7
retrieving revision 1.3.6.8
diff -u -r1.3.6.7 -r1.3.6.8
--- squid/src/icp_v2.c	1 Jul 2007 08:34:28 -0000	1.3.6.7
+++ squid/src/icp_v2.c	2 Jul 2007 07:36:59 -0000	1.3.6.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v2.c,v 1.3.6.7 2007/07/01 08:34:28 amosjeffries Exp $
+ * $Id: icp_v2.c,v 1.3.6.8 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -35,8 +35,8 @@
 
 #include "squid.h"
 
-static void icpLogIcp(struct sockaddr *, log_type, int, const char *, int);
-static void icpHandleIcpV2(int, struct sockaddr *, char *, int);
+static void icpLogIcp(struct in_addr, log_type, int, const char *, int);
+static void icpHandleIcpV2(int, struct sockaddr_in, char *, int);
 static void icpCount(void *, int, size_t, int);
 
 /*
@@ -46,7 +46,7 @@
 static icpUdpData *IcpQueueTail = NULL;
 
 static void
-icpLogIcp(struct sockaddr *caddr, log_type logcode, int len, const char *url, int delay)
+icpLogIcp(struct in_addr caddr, log_type logcode, int len, const char *url, int delay)
 {
     AccessLogEntry al;
     if (LOG_TAG_NONE == logcode)
@@ -59,7 +59,7 @@
     memset(&al, '\0', sizeof(al));
     al.icp.opcode = ICP_QUERY;
     al.url = url;
-    xmemcpy(&al.cache.caddr, caddr, SOCKLEN(caddr));
+    al.cache.caddr = caddr;
     al.cache.size = len;
     al.cache.code = logcode;
     al.cache.msec = delay;
@@ -106,7 +106,7 @@
     headerp->reqnum = htonl(reqnum);
     headerp->flags = htonl(flags);
     headerp->pad = htonl(pad);
-    xmemcpy(&headerp->shostid, &theOutICPAddr, sizeof(struct sockaddr_storage));
+    headerp->shostid = theOutICPAddr.s_addr;
     urloffset = buf + sizeof(icp_common_t);
     if (opcode == ICP_QUERY)
 	urloffset += sizeof(u_num32);
@@ -116,7 +116,7 @@
 
 int
 icpUdpSend(int fd,
-    const struct sockaddr *to,
+    const struct sockaddr_in *to,
     icp_common_t * msg,
     log_type logcode,
     int delay)
@@ -124,25 +124,23 @@
     icpUdpData *queue;
     int x;
     int len;
-    char host[100], port[8];
     len = (int) ntohs(msg->length);
-    getnameinfo(to, SOCKLEN(to), host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-    debug(12, 5) ("icpUdpSend: FD %d sending %s, %d bytes to %s:%s\n",
+    debug(12, 5) ("icpUdpSend: FD %d sending %s, %d bytes to %s:%d\n",
 	fd,
 	icp_opcode_str[msg->opcode],
 	len,
-	host,
-	port);
-    x = comm_udp_sendto(fd, to, SOCKLEN(to), msg, len);
+	inet_ntoa(to->sin_addr),
+	ntohs(to->sin_port));
+    x = comm_udp_sendto(fd, to, sizeof(*to), msg, len);
     if (x >= 0) {
 	/* successfully written */
-	icpLogIcp(to, logcode, len, (char *) (msg + 1), delay);
+	icpLogIcp(to->sin_addr, logcode, len, (char *) (msg + 1), delay);
 	icpCount(msg, SENT, (size_t) len, delay);
 	safe_free(msg);
     } else if (0 == delay) {
 	/* send failed, but queue it */
 	queue = xcalloc(1, sizeof(icpUdpData));
-	xmemcpy(&queue->address, to, SOCKLEN(to));
+	queue->address = *to;
 	queue->msg = msg;
 	queue->len = (int) ntohs(msg->length);
 	queue->queue_time = current_time;
@@ -181,7 +179,7 @@
 }
 
 static void
-icpHandleIcpV2(int fd, struct sockaddr *from, char *buf, int len)
+icpHandleIcpV2(int fd, struct sockaddr_in from, char *buf, int len)
 {
     icp_common_t header;
     StoreEntry *entry = NULL;
@@ -226,23 +224,22 @@
 	    break;
 	}
 	memset(&checklist, '\0', sizeof(checklist));
-	xmemcpy(&checklist.src_addr, from, SOCKLEN(from));
-	memset(&checklist.my_addr, 0, sizeof(checklist.my_addr));
-	checklist.my_addr.ss_family = checklist.src_addr.ss_family;
+	checklist.src_addr = from.sin_addr;
+	checklist.my_addr = no_addr;
 	checklist.request = icp_request;
 	allow = aclCheckFast(Config.accessList.icp, &checklist);
 	if (!allow) {
 	    debug(12, 2) ("icpHandleIcpV2: Access Denied for %s by %s.\n",
-		sockaddr_ntoa(from), AclMatchedName);
-	    if (clientdbCutoffDenied(from)) {
+		inet_ntoa(from.sin_addr), AclMatchedName);
+	    if (clientdbCutoffDenied(from.sin_addr)) {
 		/*
 		 * count this DENIED query in the clientdb, even though
 		 * we're not sending an ICP reply...
 		 */
-		clientdbUpdate(from, LOG_UDP_DENIED, PROTO_ICP, 0);
+		clientdbUpdate(from.sin_addr, LOG_UDP_DENIED, PROTO_ICP, 0);
 	    } else {
 		reply = icpCreateMessage(ICP_DENIED, 0, url, header.reqnum, 0);
-		icpUdpSend(fd, from, reply, LOG_UDP_DENIED, 0);
+		icpUdpSend(fd, &from, reply, LOG_UDP_DENIED, 0);
 	    }
 	    break;
 	}
@@ -258,7 +255,7 @@
 	debug(12, 5) ("icpHandleIcpV2: OPCODE %s\n", icp_opcode_str[header.opcode]);
 	if (icpCheckUdpHit(entry, icp_request)) {
 	    reply = icpCreateMessage(ICP_HIT, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, from, reply, LOG_UDP_HIT, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_HIT, 0);
 	    break;
 	}
 	if (Config.onoff.test_reachability && rtt == 0) {
@@ -268,16 +265,16 @@
 	/* if store is rebuilding, return a UDP_HIT, but not a MISS */
 	if (store_dirs_rebuilding && opt_reload_hit_only) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else if (hit_only_mode_until > squid_curtime) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else if (Config.onoff.test_reachability && rtt == 0) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else {
 	    reply = icpCreateMessage(ICP_MISS, flags, url, header.reqnum, src_rtt);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS, 0);
 	}
 	break;
 
@@ -291,18 +288,18 @@
     case ICP_MISS_NOFETCH:
 	if (neighbors_do_private_keys && header.reqnum == 0) {
 	    debug(12, 0) ("icpHandleIcpV2: Neighbor %s returned reqnum = 0\n",
-		sockaddr_ntoa(from));
+		inet_ntoa(from.sin_addr));
 	    debug(12, 0) ("icpHandleIcpV2: Disabling use of private keys\n");
 	    neighbors_do_private_keys = 0;
 	}
 	url = buf + sizeof(icp_common_t);
 	debug(12, 3) ("icpHandleIcpV2: %s from %s for '%s'\n",
 	    icp_opcode_str[header.opcode],
-	    sockaddr_ntoa(from),
+	    inet_ntoa(from.sin_addr),
 	    url);
 	key = icpGetCacheKey(url, (int) header.reqnum);
 	/* call neighborsUdpAck even if ping_status != PING_WAITING */
-	neighborsUdpAck(key, &header, from);
+	neighborsUdpAck(key, &header, &from);
 	break;
 
     case ICP_INVALID:
@@ -311,7 +308,7 @@
 
     default:
 	debug(12, 0) ("icpHandleIcpV2: UNKNOWN OPCODE: %d from %s\n",
-	    header.opcode, sockaddr_ntoa(from));
+	    header.opcode, inet_ntoa(from.sin_addr));
 	break;
     }
     if (icp_request)
@@ -341,7 +338,7 @@
 icpHandleUdp(int sock, void *data)
 {
     int *N = &incoming_sockets_accepted;
-    struct sockaddr_storage from;
+    struct sockaddr_in from;
     socklen_t from_len;
     LOCAL_ARRAY(char, buf, SQUID_UDP_SO_RCVBUF);
     int len;
@@ -380,7 +377,7 @@
 	debug(12, 4) ("icpHandleUdp: FD %d: received %d bytes from %s.\n",
 	    sock,
 	    len,
-	    sockaddr_ntoa(&from));
+	    inet_ntoa(from.sin_addr));
 #ifdef ICP_PACKET_DUMP
 	icpPktDump(buf);
 #endif
@@ -390,17 +387,14 @@
 	}
 	icp_version = (int) buf[1];	/* cheat! */
 	if (icp_version == ICP_VERSION_2)
-	    icpHandleIcpV2(sock, &from, buf, len);
+	    icpHandleIcpV2(sock, from, buf, len);
 	else if (icp_version == ICP_VERSION_3)
-	    icpHandleIcpV3(sock, &from, buf, len);
+	    icpHandleIcpV3(sock, from, buf, len);
 	else
 	    debug(12, 1) ("WARNING: Unused ICP version %d received from %s:%d\n",
 		icp_version,
-		sockaddr_ntoa(&from),
-		from.ss_family == AF_INET6 ? 
-		    ntohs(((struct sockaddr_in6 *)&from)->sin6_port) :
-		    ntohs(((struct sockaddr_in *)&from)->sin_port) 
-		);
+		inet_ntoa(from.sin_addr),
+		ntohs(from.sin_port));
     }
 }
 
@@ -408,28 +402,20 @@
 icpConnectionsOpen(void)
 {
     u_short port;
-    struct sockaddr_storage addr;
-    struct sockaddr_storage xaddr;
+    struct in_addr addr;
+    struct sockaddr_in xaddr;
     int x;
     socklen_t len;
     wordlist *s;
     if ((port = Config.Port.icp) <= 0)
 	return;
     enter_suid();
-    xmemcpy(&addr, &Config.Addrs.udp_incoming, sizeof(addr));
-    ((struct sockaddr_in *)&addr)->sin_port = htons(port);
     theInIcpConnection = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	&addr,
+	Config.Addrs.udp_incoming,
+	port,
 	COMM_NONBLOCKING,
 	"ICP Socket");
-    xmemcpy(&addr, &Config.Addrs.udp6_incoming, sizeof(addr));
-    ((struct sockaddr_in6 *)&addr)->sin6_port = htons(port);
-    theInIcpConnection6 = comm_open(SOCK_DGRAM,
-	IPPROTO_UDP,
-	&addr,
-	COMM_NONBLOCKING,
-	"ICP Socket v6");
     leave_suid();
     if (theInIcpConnection < 0)
 	fatal("Cannot open ICP Port");
@@ -438,29 +424,17 @@
 	icpHandleUdp,
 	NULL,
 	0);
-    if (theInIcpConnection6 < 0)
-	fatal("Cannot open ICP Port v6");
-    commSetSelect(theInIcpConnection6,
-	COMM_SELECT_READ,
-	icpHandleUdp,
-	NULL,
-	0);
     for (s = Config.mcast_group_list; s; s = s->next)
 	ipcache_nbgethostbyname(s->key, mcastJoinGroups, NULL);
     debug(12, 1) ("Accepting ICP messages at %s, port %d, FD %d.\n",
-	sockaddr_ntoa(&Config.Addrs.udp_incoming),
+	inet_ntoa(Config.Addrs.udp_incoming),
 	(int) port, theInIcpConnection);
-    debug(12, 1) ("Accepting ICP messages v6 at %s, port %d, FD %d.\n",
-	sockaddr_ntoa(&Config.Addrs.udp6_incoming),
-	(int) port, theInIcpConnection6);
-
-    if (((struct sockaddr_in *)&Config.Addrs.udp_outgoing)->sin_addr.s_addr != no_addr.s_addr) {
-	xmemcpy(&addr, &Config.Addrs.udp_outgoing, sizeof(addr));
-	((struct sockaddr_in *)&addr)->sin_port = htons(port);
+    if ((addr = Config.Addrs.udp_outgoing).s_addr != no_addr.s_addr) {
 	enter_suid();
 	theOutIcpConnection = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    &addr,
+	    addr,
+	    port,
 	    COMM_NONBLOCKING,
 	    "ICP Port");
 	leave_suid();
@@ -478,33 +452,8 @@
     } else {
 	theOutIcpConnection = theInIcpConnection;
     }
-    if (!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&Config.Addrs.udp6_outgoing)->sin6_addr) ) {
-	xmemcpy(&addr, &Config.Addrs.udp6_outgoing, sizeof(addr));
-	((struct sockaddr_in6 *)&addr)->sin6_port = htons(port);
-	enter_suid();
-	theOutIcpConnection6 = comm_open(SOCK_DGRAM,
-	    IPPROTO_UDP,
-	    &addr,
-	    COMM_NONBLOCKING,
-	    "ICP Port v6");
-	leave_suid();
-	if (theOutIcpConnection6 < 0)
-	    fatal("Cannot open Outgoing ICP Port v6");
-	commSetSelect(theOutIcpConnection6,
-	    COMM_SELECT_READ,
-	    icpHandleUdp,
-	    NULL,
-	    0);
-	debug(12, 1) ("Outgoing ICP messages v6 on port %d, FD %d.\n",
-	    (int) port, theOutIcpConnection6);
-	fd_note(theOutIcpConnection6, "Outgoing ICP socket v6");
-	fd_note(theInIcpConnection6, "Incoming ICP socket v6");
-    } else {
-	theOutIcpConnection6 = theInIcpConnection6;
-    }
-
-    memset(&theOutICPAddr, '\0', sizeof(struct sockaddr_storage));
-    len = sizeof(struct sockaddr_storage);
+    memset(&theOutICPAddr, '\0', sizeof(struct in_addr));
+    len = sizeof(struct sockaddr_in);
     memset(&xaddr, '\0', len);
     x = getsockname(theOutIcpConnection,
 	(struct sockaddr *) &xaddr, &len);
@@ -512,18 +461,7 @@
 	debug(12, 1) ("theOutIcpConnection FD %d: getsockname: %s\n",
 	    theOutIcpConnection, xstrerror());
     else
-	xmemcpy(&theOutICPAddr, &xaddr, sizeof(xaddr));
-
-    memset(&theOutICPAddr6, '\0', sizeof(struct sockaddr_storage));
-    len = sizeof(struct sockaddr_storage);
-    memset(&xaddr, '\0', len);
-    x = getsockname(theOutIcpConnection6,
-	(struct sockaddr *) &xaddr, &len);
-    if (x < 0)
-	debug(12, 1) ("theOutIcpConnection6 FD %d: getsockname: %s\n",
-	    theOutIcpConnection6, xstrerror());
-    else
-	xmemcpy(&theOutICPAddr6, &xaddr, sizeof(xaddr));
+	theOutICPAddr = xaddr.sin_addr;
 }
 
 /*
@@ -533,16 +471,12 @@
 void
 icpConnectionShutdown(void)
 {
-    if (theInIcpConnection < 0 && theInIcpConnection6 < 0)
+    if (theInIcpConnection < 0)
 	return;
-    if (theInIcpConnection > 0 && theInIcpConnection != theOutIcpConnection) {
+    if (theInIcpConnection != theOutIcpConnection) {
 	debug(12, 1) ("FD %d Closing ICP connection\n", theInIcpConnection);
 	comm_close(theInIcpConnection);
     }
-    if (theInIcpConnection6> 0 && theInIcpConnection6!=theOutIcpConnection6) {
-	debug(12, 1) ("FD %d Closing ICP connection6\n", theInIcpConnection6);
-	comm_close(theInIcpConnection6);
-    }
     /*
      * Here we set 'theInIcpConnection' to -1 even though the ICP 'in'
      * and 'out' sockets might be just one FD.  This prevents this
@@ -550,7 +484,6 @@
      * exit or restart, main will comm_close the 'out' descriptor.
      */
     theInIcpConnection = -1;
-    theInIcpConnection6 = -1;
     /*
      * Normally we only write to the outgoing ICP socket, but
      * we also have a read handler there to catch messages sent
@@ -558,9 +491,7 @@
      * disable reading on the outgoing socket.
      */
     assert(theOutIcpConnection > -1);
-    assert(theOutIcpConnection6 > -1);
     commSetSelect(theOutIcpConnection, COMM_SELECT_READ, NULL, NULL, 0);
-    commSetSelect(theOutIcpConnection6, COMM_SELECT_READ, NULL, NULL, 0);
 }
 
 void
@@ -572,11 +503,6 @@
 	comm_close(theOutIcpConnection);
 	theOutIcpConnection = -1;
     }
-    if (theOutIcpConnection6 > -1) {
-	debug(12, 1) ("FD %d Closing ICP connection\n", theOutIcpConnection6);
-	comm_close(theOutIcpConnection6);
-	theOutIcpConnection6 = -1;
-    }
 }
 
 static void
Index: squid/src/icp_v3.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v3.c,v
retrieving revision 1.3.6.4
retrieving revision 1.3.6.5
diff -u -r1.3.6.4 -r1.3.6.5
--- squid/src/icp_v3.c	1 Jul 2007 05:44:22 -0000	1.3.6.4
+++ squid/src/icp_v3.c	2 Jul 2007 07:36:59 -0000	1.3.6.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v3.c,v 1.3.6.4 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: icp_v3.c,v 1.3.6.5 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -37,7 +37,7 @@
 
 /* Currently Harvest cached-2.x uses ICP_VERSION_3 */
 void
-icpHandleIcpV3(int fd, struct sockaddr *from, char *buf, int len)
+icpHandleIcpV3(int fd, struct sockaddr_in from, char *buf, int len)
 {
     icp_common_t header;
     icp_common_t *reply;
@@ -69,32 +69,31 @@
 	if (strpbrk(url, w_space)) {
 	    url = rfc1738_escape(url);
 	    reply = icpCreateMessage(ICP_ERR, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, from, reply, LOG_UDP_INVALID, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_INVALID, 0);
 	    break;
 	}
 	if ((icp_request = urlParse(METHOD_GET, url)) == NULL) {
 	    reply = icpCreateMessage(ICP_ERR, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, from, reply, LOG_UDP_INVALID, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_INVALID, 0);
 	    break;
 	}
 	memset(&checklist, '\0', sizeof(checklist));
-	xmemcpy(&checklist.src_addr, from, SOCKLEN(from));
-	memset(&checklist.my_addr, '\0', sizeof(checklist.my_addr));
-	checklist.my_addr.ss_family = from->sa_family;
+	checklist.src_addr = from.sin_addr;
+	checklist.my_addr = no_addr;
 	checklist.request = icp_request;
 	allow = aclCheckFast(Config.accessList.icp, &checklist);
 	if (!allow) {
 	    debug(12, 2) ("icpHandleIcpV3: Access Denied for %s by %s.\n",
-		sockaddr_ntoa(from), AclMatchedName);
-	    if (clientdbCutoffDenied(from)) {
+		inet_ntoa(from.sin_addr), AclMatchedName);
+	    if (clientdbCutoffDenied(from.sin_addr)) {
 		/*
 		 * count this DENIED query in the clientdb, even though
 		 * we're not sending an ICP reply...
 		 */
-		clientdbUpdate(from, LOG_UDP_DENIED, PROTO_ICP, 0);
+		clientdbUpdate(from.sin_addr, LOG_UDP_DENIED, PROTO_ICP, 0);
 	    } else {
 		reply = icpCreateMessage(ICP_DENIED, 0, url, header.reqnum, 0);
-		icpUdpSend(fd, from, reply, LOG_UDP_DENIED, 0);
+		icpUdpSend(fd, &from, reply, LOG_UDP_DENIED, 0);
 	    }
 	    break;
 	}
@@ -104,19 +103,19 @@
 	    icp_opcode_str[header.opcode]);
 	if (icpCheckUdpHit(entry, icp_request)) {
 	    reply = icpCreateMessage(ICP_HIT, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, from, reply, LOG_UDP_HIT, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_HIT, 0);
 	    break;
 	}
 	/* if store is rebuilding, return a UDP_HIT, but not a MISS */
 	if (opt_reload_hit_only && store_dirs_rebuilding) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else if (hit_only_mode_until > squid_curtime) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else {
 	    reply = icpCreateMessage(ICP_MISS, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, from, reply, LOG_UDP_MISS, 0);
+	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS, 0);
 	}
 	break;
 
@@ -130,18 +129,18 @@
     case ICP_MISS_NOFETCH:
 	if (neighbors_do_private_keys && header.reqnum == 0) {
 	    debug(12, 0) ("icpHandleIcpV3: Neighbor %s returned reqnum = 0\n",
-		sockaddr_ntoa(from));
+		inet_ntoa(from.sin_addr));
 	    debug(12, 0) ("icpHandleIcpV3: Disabling use of private keys\n");
 	    neighbors_do_private_keys = 0;
 	}
 	url = buf + sizeof(icp_common_t);
 	debug(12, 3) ("icpHandleIcpV3: %s from %s for '%s'\n",
 	    icp_opcode_str[header.opcode],
-	    sockaddr_ntoa(from),
+	    inet_ntoa(from.sin_addr),
 	    url);
 	key = icpGetCacheKey(url, (int) header.reqnum);
 	/* call neighborsUdpAck even if ping_status != PING_WAITING */
-	neighborsUdpAck(key, &header, from);
+	neighborsUdpAck(key, &header, &from);
 	break;
 
     case ICP_INVALID:
@@ -150,7 +149,7 @@
 
     default:
 	debug(12, 0) ("icpHandleIcpV3: UNKNOWN OPCODE: %d from %s\n",
-	    header.opcode, sockaddr_ntoa(from));
+	    header.opcode, inet_ntoa(from.sin_addr));
 	break;
     }
     if (icp_request)
Index: squid/src/ident.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ident.c,v
retrieving revision 1.4.6.6
retrieving revision 1.4.6.7
diff -u -r1.4.6.6 -r1.4.6.7
--- squid/src/ident.c	1 Jul 2007 05:44:23 -0000	1.4.6.6
+++ squid/src/ident.c	2 Jul 2007 07:36:59 -0000	1.4.6.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ident.c,v 1.4.6.6 2007/07/01 05:44:23 amosjeffries Exp $
+ * $Id: ident.c,v 1.4.6.7 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 30    Ident (RFC 931)
  * AUTHOR: Duane Wessels
@@ -48,10 +48,9 @@
 
 typedef struct _IdentStateData {
     hash_link hash;		/* must be first */
-    int ia_cur;			/* dummy, for commConnectStart */
     int fd;			/* IDENT fd */
-    struct sockaddr_storage me;
-    struct sockaddr_storage my_peer;
+    struct sockaddr_in me;
+    struct sockaddr_in my_peer;
     IdentClient *clients;
 } IdentStateData;
 
@@ -95,7 +94,7 @@
 {
     IdentStateData *state = data;
     debug(30, 3) ("identTimeout: FD %d, %s\n", fd,
-	sockaddr_ntoa(&state->my_peer));
+	inet_ntoa(state->my_peer.sin_addr));
     comm_close(fd);
 }
 
@@ -124,12 +123,8 @@
     }
     memBufDefInit(&mb);
     memBufPrintf(&mb, "%d, %d\r\n",
-	(state->my_peer.ss_family == AF_INET6) ?
-	ntohs(((struct sockaddr_in6 *)&state->my_peer)->sin6_port):
-	ntohs(((struct sockaddr_in *)&state->my_peer)->sin_port),
-	(state->my_peer.ss_family == AF_INET6) ?
-	ntohs(((struct sockaddr_in6 *)&state->me)->sin6_port):
-	ntohs(((struct sockaddr_in *)&state->me)->sin_port) );
+	ntohs(state->my_peer.sin_port),
+	ntohs(state->me.sin_port));
     comm_write_mbuf(fd, mb, NULL, state);
     commSetSelect(fd, COMM_SELECT_READ, identReadReply, state, 0);
     commSetTimeout(fd, Config.Timeout.ident, identTimeout, state);
@@ -192,18 +187,19 @@
  * start a TCP connection to the peer host on port 113
  */
 void
-identStart(struct sockaddr *me, struct sockaddr *my_peer, IDCB * callback, void *data)
+identStart(struct sockaddr_in *me, struct sockaddr_in *my_peer, IDCB * callback, void *data)
 {
     IdentStateData *state;
     int fd;
     char key1[IDENT_KEY_SZ];
     char key2[IDENT_KEY_SZ];
     char key[IDENT_KEY_SZ];
-    char ahost[100], aport[8];
-    getnameinfo(me, SOCKLEN(me), ahost, 100, aport, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-    snprintf(key1, IDENT_KEY_SZ, "%s:%s", ahost, aport);
-    getnameinfo(my_peer, SOCKLEN(my_peer), ahost, 100, aport, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-    snprintf(key2, IDENT_KEY_SZ, "%s:%s", ahost, aport);
+    snprintf(key1, IDENT_KEY_SZ, "%s:%d",
+	inet_ntoa(me->sin_addr),
+	ntohs(me->sin_port));
+    snprintf(key2, IDENT_KEY_SZ, "%s:%d",
+	inet_ntoa(my_peer->sin_addr),
+	ntohs(my_peer->sin_port));
     snprintf(key, IDENT_KEY_SZ, "%s,%s", key1, key2);
     if ((state = hash_lookup(ident_hash, key)) != NULL) {
 	identClientAdd(state, callback, data);
@@ -211,7 +207,8 @@
     }
     fd = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	me,
+	me->sin_addr,
+	0,
 	COMM_NONBLOCKING,
 	"ident");
     if (fd == COMM_ERROR) {
@@ -223,8 +220,8 @@
     state = cbdataAlloc(IdentStateData);
     state->hash.key = xstrdup(key);
     state->fd = fd;
-    xmemcpy(&state->me, me, SOCKLEN(me));
-    xmemcpy(&state->my_peer, my_peer, SOCKLEN(my_peer));
+    state->me = *me;
+    state->my_peer = *my_peer;
     identClientAdd(state, callback, data);
     hash_join(ident_hash, &state->hash);
     comm_add_close_handler(fd,
@@ -232,7 +229,8 @@
 	state);
     commSetTimeout(fd, Config.Timeout.ident, identTimeout, state);
     commConnectStart(fd,
-	sockaddr_ntoa(my_peer), IDENT_PORT,
+	inet_ntoa(state->my_peer.sin_addr),
+	IDENT_PORT,
 	identConnectDone,
 	state,
 	NULL);
Index: squid/src/internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/internal.c,v
retrieving revision 1.5.2.4
retrieving revision 1.5.2.5
diff -u -r1.5.2.4 -r1.5.2.5
--- squid/src/internal.c	1 Jul 2007 05:44:23 -0000	1.5.2.4
+++ squid/src/internal.c	2 Jul 2007 07:36:59 -0000	1.5.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: internal.c,v 1.5.2.4 2007/07/01 05:44:23 amosjeffries Exp $
+ * $Id: internal.c,v 1.5.2.5 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 76    Internal Squid Object handling
  * AUTHOR: Duane, Alex, Henrik
@@ -45,7 +45,7 @@
     ErrorState *err;
     const char *upath = strBuf(request->urlpath);
     debug(76, 3) ("internalStart: %s requesting '%s'\n",
-	sockaddr_ntoa(&request->client_addr), upath);
+	inet_ntoa(request->client_addr), upath);
     if (0 == strcmp(upath, "/squid-internal-dynamic/netdb")) {
 	netdbBinaryExchange(entry);
     } else if (0 == strcmp(upath, "/squid-internal-periodic/store_digest")) {
@@ -90,17 +90,10 @@
     /* convert host name to lower case */
     xstrncpy(lc_host, host, SQUIDHOSTNAMELEN);
     Tolower(lc_host);
-
-    /*
-     * host is IPv6 address
-     */
-    if (strchr(lc_host, ':'))
-	snprintf(lc_host, SQUIDHOSTNAMELEN, "[%s]", host);
     /*
      * append the domain in order to mirror the requests with appended
      * domains
      */
-    else
     if (Config.appendDomain && !strchr(lc_host, '.'))
 	strncat(lc_host, Config.appendDomain, SQUIDHOSTNAMELEN -
 	    strlen(lc_host) - 1);
Index: squid/src/ipc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipc.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/ipc.c	1 Jul 2007 05:44:23 -0000	1.3.6.5
+++ squid/src/ipc.c	2 Jul 2007 07:36:59 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipc.c,v 1.3.6.5 2007/07/01 05:44:23 amosjeffries Exp $
+ * $Id: ipc.c,v 1.3.6.6 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 54    Interprocess Communication
  * AUTHOR: Duane Wessels
@@ -87,32 +87,30 @@
     if (hIpc)
 	*hIpc = NULL;
 
-    CS.sin_family = AF_INET;
-#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
-    CS.sin_len = sizeof(CS);
-#endif
-    CS.sin_addr = local_addr;
-    CS.sin_port = 0;
     if (type == IPC_TCP_SOCKET) {
 	crfd = cwfd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,
-	    &CS,
+	    local_addr,
+	    0,
 	    COMM_NOCLOEXEC,
 	    name);
 	prfd = pwfd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,	/* protocol */
-	    &CS,
+	    local_addr,
+	    0,			/* port */
 	    0,			/* blocking */
 	    name);
     } else if (type == IPC_UDP_SOCKET) {
 	crfd = cwfd = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    &CS,
+	    local_addr,
+	    0,
 	    COMM_NOCLOEXEC,
 	    name);
 	prfd = pwfd = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    &CS,
+	    local_addr,
+	    0,
 	    0,
 	    name);
     } else if (type == IPC_FIFO) {
